## ncsa.hdf.object.h4
Class H4GRImage

    java.lang.Object
      ncsa.hdf.object.HObject
          ncsa.hdf.object.Dataset
              ncsa.hdf.object.ScalarDS
                  ncsa.hdf.object.h4.H4GRImage

All Implemented Interfaces:
  java.io.Serializable, DataFormat

    public class H4GRImage

extends ScalarDS

H4GRImage describes HDF4 general raster(GR) image and operations performed on the GR image. An HDF4 raster image is a two-dimension array of pixel values.

Every GR data set must contain the following components: image array, name, pixel type, and dimensions. The name, dimensions, and pixel type must be supplied by the user at the time the GR data set is defined.

An image array is a two-dimensional array of pixels. Each element in an image array corresponds to one pixel and each pixel can consist of a number of color component values or pixel components, e.g., Red-Green-Blue or RGB, Cyan-Magenta-Yellow-Black or CMYK, etc. Pixel components can be represented by different methods (8-bit lookup table or 24-bit direct representation) and may have different data types. The data type of pixel components and the number of components in each pixel are collectively known as the pixel type.

How to Select a Subset

Dataset defines APIs for read, write and subet a dataset. No function is defined to select a subset of a data array. The selection is done in an implicit way. Function calls to dimension information such as getSelectedDims() return an array of dimension values, which is a reference to the array in the dataset object. Changes of the array outside the dataset object directly change the values of the array in the dataset object. It is like pointers in C.

The following is an example of how to make a subset. In the example, the dataset is a 4-dimension with size of [200][100][50][10], i.e. dims[0]=200; dims[1]=100; dims[2]=50; dims[3]=10;
We want to select every other data points in dims[1] and dims[2]

###

###

###

###

###

###

###

###

###

###

###

###

###

###

###

###

###

###

###

###

         int rank = dataset.getRank();   // number of dimension of the dataset
         long[] dims = dataset.getDims(); // the dimension sizes of the dataset
         long[] selected = dataset.getSelectedDims(); // the selected size of the dataet
         long[] start = dataset.getStartDims(); // the off set of the selection
         long[] stride = dataset.getStride(); // the stride of the dataset
         int[]  selectedIndex = dataset.getSelectedIndex(); // the selected dimensions for display

         // select dim1 and dim2 as 2D data for display,and slice through dim0
         selectedIndex[0] = 1;
         selectedIndex[1] = 2;
         selectedIndex[1] = 0;

         // reset the selection arrays
         for (int i=0; i<rank; i++) {
             start[i] = 0;
             selected[i] = 1;
             stride[i] = 1;
        }

        // set stride to 2 on dim1 and dim2 so that every other data points are selected.
        stride[1] = 2;
        stride[2] = 2;

        // set the selection size of dim1 and dim2
        selected[1] = dims[1]/stride[1];
        selected[2] = dims[1]/stride[2];

        // when dataset.read() is called, the slection above will be used since
        // the dimension arrays is passed by reference. Changes of these arrays
        // outside the dataset object directly change the values of these array
        // in the dataset object.

     </pre>

    Version:
      1.1 9/4/2007
    Author:
      Peter X. Cao
    See Also:Serialized Form

    Field Summary

    Fields inherited from class ncsa.hdf.object.ScalarDS

    fillValue, imageDataRange, interlace, INTERLACE_LINE, INTERLACE_PIXEL, INTERLACE_PLANE, isDefaultImageOrder, isFillValueConverted, isImage, isImageDisplay, isText, isTrueColor, isUnsigned, palette, unsignedConverted

    Fields inherited from class ncsa.hdf.object.Dataset

    chunkSize, compression, convertByteToString, convertedBuf, data, datatype, dimNames, dims, enumConverted, isDataLoaded, maxDims, nPoints, originalBuf, rank, selectedDims, selectedIndex, selectedStride, startDims

    Fields inherited from class ncsa.hdf.object.HObject

    linkTargetObjName, oid, separator

    Constructor Summary

    H4GRImage(FileFormat theFile,
              java.lang.String name,
              java.lang.String path)

    H4GRImage(FileFormat theFile,
              java.lang.String name,
              java.lang.String path,
              long[] oid)

              Creates a H4GRImage object with specific name, path, and object ID.

    Method Summary

     void
    close(int grid)

              Closes access to the object.

     Dataset
    copy(Group pgroup,
         java.lang.String dname,
         long[] dims,
         java.lang.Object buff)

              Creates a new dataset and writes the data buffer to the new dataset.

    static H4GRImage
    create(java.lang.String name,
           Group pgroup,
           Datatype type,
           long[] dims,
           long[] maxdims,
           long[] chunks,
           int gzip,
           int ncomp,
           int interlace,
           java.lang.Object data)

              Creates a new image.

     int
    getComponentCount()

              Returns the number of components of this image data.

     Datatype
    getDatatype()

              Returns the datatype object of the dataset.

     java.util.List
    getMetadata()

              Retrieves the metadata such as attributes from file.

     java.util.List
    getMetadata(int... attrPropList)

     byte[][]
    getPalette()

              Returns the palette of this scalar dataset or null if palette does not
     exist.

     byte[]
    getPaletteRefs()

              Returns the byte array of palette refs.

     boolean
    hasAttribute()

              Check if the object has any attributes attached.

     void
    init()

              Retrieves datatype and dataspace information from file and sets the
     dataset in memory.

     int
    open()

              Opens an existing object such as dataset or group for access.

     java.lang.Object
    read()

              Reads the data from file.

     byte[]
    readBytes()

              Reads the raw data of the dataset from file to a byte array.

     byte[][]
    readPalette(int idx)

              Reads a specific image palette from file.

     void
    removeMetadata(java.lang.Object info)

              Deletes an existing metadata from this data object.

     void
    write(java.lang.Object buf)

              Writes a memory buffer to the dataset in file.

     void
    writeMetadata(java.lang.Object info)

              Writes a specific metadata (such as attribute) into file.

    Methods inherited from class ncsa.hdf.object.ScalarDS

    clearData, convertFromUnsignedC, convertToUnsignedC, getFillValue, getImageDataRange, getInterlace, getPaletteName, isDefaultImageOrder, isImage, isImageDisplay, isText, isTrueColor, isUnsigned, setIsImage, setIsImageDisplay, setPalette

    Methods inherited from class ncsa.hdf.object.Dataset

    byteToString, clear, convertFromUnsignedC, convertFromUnsignedC, convertToUnsignedC, convertToUnsignedC, getChunkSize, getCompression, getConvertByteToString, getData, getDimNames, getDims, getHeight, getMaxDims, getRank, getSelectedDims, getSelectedIndex, getSize, getStartDims, getStride, getWidth, isEnumConverted, isString, setConvertByteToString, setData, setEnumConverted, stringToByte, write

    Methods inherited from class ncsa.hdf.object.HObject

    debug, equalsOID, getFID, getFile, getFileFormat, getFullName, getLinkTargetObjName, getName, getOID, getPath, setLinkTargetObjName, setName, setPath, toString

    Methods inherited from class java.lang.Object

    clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait

    Constructor Detail

    H4GRImage

    public H4GRImage(FileFormat theFile,
                     java.lang.String name,
                     java.lang.String path)

    H4GRImage

    public H4GRImage(FileFormat theFile,
                     java.lang.String name,
                     java.lang.String path,
                     long[] oid)

    Creates a H4GRImage object with specific name, path, and object ID.

    Parameters:theFile - the HDF file.name - the name of this H4GRImage.path - the full path of this H4GRImage.oid - the unique identifier of this data object.

    Method Detail

    hasAttribute

    public boolean hasAttribute()

    Description copied from interface: DataFormat
    Check if the object has any attributes attached.

    Returns:true if it has any attribute(s), false otherwise.

    copy

    public Dataset copy(Group pgroup,
                        java.lang.String dname,
                        long[] dims,
                        java.lang.Object buff)
                 throws java.lang.Exception

    Description copied from class: Dataset
    Creates a new dataset and writes the data buffer to the new dataset.

     This function allows applications to create a new dataset for a given
     data buffer. For example, users can select a specific interesting part
     from a large image and create a new image with the selection.

     The new dataset retains the datatype and dataset creation properties of
     this dataset.

    Specified by:copy in class Dataset

    Parameters:pgroup - the group which the dataset is copied to.dname - the name of the new dataset.dims - the dimension sizes of the the new dataset.buff - the data values of the subset to be copied.
    Returns:the new dataset.
    Throws:
    java.lang.Exception

    readPalette

    public byte[][] readPalette(int idx)

    Description copied from class: ScalarDS
    Reads a specific image palette from file.

     A scalar dataset may have multiple palettes attached to it.
     readPalette(int idx) returns a specific palette identified by its index.

    Specified by:readPalette in class ScalarDS

    Parameters:idx - the index of the palette to read.

    getPaletteRefs

    public byte[] getPaletteRefs()

    Description copied from class: ScalarDS
    Returns the byte array of palette refs.

     A palette reference is an object reference that points to the palette
     dataset.

     For example, Dataset "Iceberg" has an attribute of object reference
     "Palette". The arrtibute "Palette" has value "2538" that is the object
     reference of the palette data set "Iceberg Palette".

    Specified by:getPaletteRefs in class ScalarDS

    Returns:null if there is no palette attribute attached to this dataset.

    getDatatype

    public Datatype getDatatype()

    Description copied from class: Dataset
    Returns the datatype object of the dataset.

    Specified by:getDatatype in class Dataset

    Returns:the datatype object of the dataset.

    readBytes

    public byte[] readBytes()
                     throws HDFException

    Description copied from class: Dataset
    Reads the raw data of the dataset from file to a byte array.

     readBytes() reads raw data to an array of bytes instead of array of its
     datatype. For example, for an one-dimension 32-bit integer dataset of
     size 5, the readBytes() returns of a byte array of size 20 instead of an
     int array of 5.

     readBytes() can be used to copy data from one dataset to another
     efficiently because the raw data is not converted to its native type, it
     saves memory space and CPU time.

    Specified by:readBytes in class Dataset

    Returns:the byte array of the raw data.
    Throws:
    HDFException

    read

    public java.lang.Object read()
                          throws HDFException

    Description copied from class: Dataset
    Reads the data from file.

     read() reads the data from file to a memory buffer and returns the memory
     buffer. The dataset object does not hold the memobry buffer. To store the
     memory buffer in the dataset object, one must call getData().

     By default, the whole dataset is read into memory. Users can also select
     subset to read. Subsetting is done in an implicit way.

     How to Select a Subset

     A selection is specified by three arrays: start, stride and count.

     start: offset of a selection
     stride: determining how many elements to move in each dimension
     count: number of elements to select in each dimension

     getStartDims(), getStartDims() and getSelectedDims() returns the start,
     stride and count arrays respectively. Applications can make a selection
     by changing the values of the arrays.

     The following example shows how to make a subset. In the example, the
     dataset is a 4-dimensional array of [200][100][50][10], i.e. dims[0]=200;
     dims[1]=100; dims[2]=50; dims[3]=10;

     We want to select every other data point in dims[1] and dims[2]

     int rank = dataset.getRank(); // number of dimension of the dataset
     long[] dims = dataset.getDims(); // the dimension sizes of the dataset
     long[] selected = dataset.getSelectedDims(); // the selected size of the dataet
     long[] start = dataset.getStartDims(); // the off set of the selection
     long[] stride = dataset.getStride(); // the stride of the dataset
     int[] selectedIndex = dataset.getSelectedIndex(); // the selected dimensions for display

     // select dim1 and dim2 as 2D data for display,and slice through dim0
     selectedIndex[0] = 1;
     selectedIndex[1] = 2;
     selectedIndex[1] = 0;

     // reset the selection arrays
     for (int i = 0; i < rank; i++) {
         start[i] = 0;
         selected[i] = 1;
         stride[i] = 1;
     }

     // set stride to 2 on dim1 and dim2 so that every other data points are selected.
     stride[1] = 2;
     stride[2] = 2;

     // set the selection size of dim1 and dim2
     selected[1] = dims[1] / stride[1];
     selected[2] = dims[1] / stride[2];

     // when dataset.getData() is called, the slection above will be used since
     // the dimension arrays are passed by reference. Changes of these arrays
     // outside the dataset object directly change the values of these array
     // in the dataset object.

     For ScalarDS, the memory data buffer is an one-dimensional array of byte,
     short, int, float, double or String type based on the datatype of the
     dataset.

     For CompoundDS, the meory data object is an java.util.List object. Each
     element of the list is a data array that corresponds to a compound field.

     For example, if compound dataset "comp" has the following nested
     structure, and memeber datatypes

     comp --> m01 (int)
     comp --> m02 (float)
     comp --> nest1 --> m11 (char)
     comp --> nest1 --> m12 (String)
     comp --> nest1 --> nest2 --> m21 (long)
     comp --> nest1 --> nest2 --> m22 (double)

     getData() returns a list of six arrays: {int[], float[], char[],
     Stirng[], long[] and double[]}.

    Specified by:read in class Dataset

    Returns:the data read from file.
    Throws:
    HDFExceptionSee Also:#getData()}

    write

    public void write(java.lang.Object buf)
               throws HDFException

    Description copied from class: Dataset
    Writes a memory buffer to the dataset in file.

    Specified by:write in class Dataset

    Parameters:buf - the data to write
    Throws:
    HDFException

    getMetadata

    public java.util.List getMetadata()
                               throws HDFException

    Description copied from interface: DataFormat
    Retrieves the metadata such as attributes from file.

     Metadata such as attributes are stored in a List.

    Returns:the list of metadata objects.
    Throws:
    HDFException

    writeMetadata

    public void writeMetadata(java.lang.Object info)
                       throws java.lang.Exception

    Description copied from interface: DataFormat
    Writes a specific metadata (such as attribute) into file.

     If an HDF(4&5) attribute exists in file, the method updates its value.
     If the attribute does not exists in file, it creates the attribute in
     file and attaches it to the object.
     It will fail to write a new attribute to the object where an attribute
     with the same name already exists.
     To update the value of an existing attribute in file, one needs to get
     the instance of the attribute by getMetadata(), change its values,
     and use writeMetadata() to write the value.

    Parameters:info - the metadata to write.
    Throws:
    java.lang.Exception

    removeMetadata

    public void removeMetadata(java.lang.Object info)
                        throws HDFException

    Description copied from interface: DataFormat
    Deletes an existing metadata from this data object.

    Parameters:info - the metadata to delete.
    Throws:
    HDFException

    open

    public int open()

    Description copied from class: HObject
    Opens an existing object such as dataset or group for access.

     The return value is an object identifier obtained by implementing classes
     such as H5.H5Dopen(). This function is needed to allow other objects to
     be able to access the object. For instance, H5File class uses the open()
     function to obtain object identifier for copyAttributes(int src_id, int
     dst_id) and other purposes. The open() function should be used in pair
     with close(int) function.

    Specified by:open in class HObject

    Returns:the object identifier if successful; otherwise returns a negative
             value.See Also:HObject.close(int)

    close

    public void close(int grid)

    Description copied from class: HObject
    Closes access to the object.

     Sub-classes must implement this interface because different data objects
     have their own ways of how the data resources are closed.

     For example, H5Group.close() calls the ncsa.hdf.hdf5lib.H5.H5Gclose()
     method and closes the group resource specified by the group id.

    Specified by:close in class HObject

    Parameters:grid - The object identifier.

    init

    public void init()

    Description copied from class: Dataset
    Retrieves datatype and dataspace information from file and sets the
     dataset in memory.

     The init() is designed to support lazy operation in dataset object. When
     a data object is retrieved from file, the datatype, dataspace and raw
     data are not loaded into memory. When it is asked to read the raw data
     from file, init() is first called to get the datatype and dataspace
     information, then load the raw data from file.

     init() is also used to reset selection of a dataset (start, stride and
     count) to the default, which is the entire dataset for 1D or 2D datasets.
     In the following example, init() at step 1) retrieve datatype and
     dataspace information from file. getData() at step 3) read only one data
     point. init() at step 4) reset the selection to the whole dataset.
     getData() at step 4) reads the values of whole dataset into memory.

     dset = (Dataset) file.get(NAME_DATASET);

     // 1) get datatype and dataspace information from file
     dset.init();
     rank = dset.getRank(); // rank = 2, a 2D dataset
     count = dset.getSelectedDims();
     start = dset.getStartDims();
     dims = dset.getDims();

     // 2) select only one data point
     for (int i = 0; i < rank; i++) {
         start[0] = 0;
         count[i] = 1;
     }

     // 3)  read one data point
     data = dset.getData();

     // 4)  reset to select the whole dataset
     dset.init();

     // 5) clean the memory data buffer
     dset.clearData();

     // 6) Read the whole dataset
     data = dset.getData();

    Specified by:init in class Dataset

    getPalette

    public byte[][] getPalette()

    Description copied from class: ScalarDS
    Returns the palette of this scalar dataset or null if palette does not
     exist.

     Scalar dataset can be displayed as spreadsheet data or image. When a
     scalar dataset is chosen to display as an image, the palette or color
     table may be needed to translate a pixel value to color components (for
     example, red, green, and blue). Some scalar datasets have no palette and
     some datasets have one or more than one palettes. If an associated
     palette exists but not loaded, this interface retrieves the palette from
     the file and returns the palette. If the palette is loaded, it returnd
     the palette. It returns null if there is no palette assciated with the
     dataset.

     Current implementation only supports palette model of indexed RGB with
     256 colors. Other models such as YUV", "CMY", "CMYK", "YCbCr", "HSV will
     be supported in the future.

     The palette values are stored in a two-dimensional byte array and arrange
     by color components of red, green and blue. palette[][] = byte[3][256],
     where, palette[0][], palette[1][] and palette[2][] are the red, green and
     blue components respectively.

     Sub-classes have to implement this interface. HDF4 and HDF5 images use
     different libraries to retrieve the associated palette.

    Specified by:getPalette in class ScalarDS

    Returns:the 2D palette byte array.

    getComponentCount

    public int getComponentCount()

    Returns the number of components of this image data.

    create

    public static H4GRImage create(java.lang.String name,
                                   Group pgroup,
                                   Datatype type,
                                   long[] dims,
                                   long[] maxdims,
                                   long[] chunks,
                                   int gzip,
                                   int ncomp,
                                   int interlace,
                                   java.lang.Object data)
                            throws java.lang.Exception

    Creates a new image.

    Parameters:name - the name of the dataset to create.pgroup - the parent group of the new dataset.type - the datatype of the dataset.dims - the dimension size of the dataset.maxdims - the max dimension size of the dataset.chunks - the chunk size of the dataset.gzip - the level of the gzip compression.ncomp - number of components of the image data.interlace - the interlace mode.data - the array of data values.
    Returns:the new image if successful. Otherwise returns null.
    Throws:
    java.lang.Exception

    getMetadata

    public java.util.List getMetadata(int... attrPropList)
                               throws java.lang.Exception

    Throws:
    java.lang.Exception